<template>
  <div class="subflow-wrap">
    <div class="title">
      <div class="tit-left">
        {{$t('userSelectBox')}}
      </div>
      <div class="tit-right">
        <div class="icon">
          <i class="fa fa-question-circle" @click="showRemind"></i>
          <div class="prompt" v-show="isShow">
            {{$t('explanation')}}
          </div>
        </div>
        <div class="add" @click="addSubflow">
          <i class="fa fa-plus i"></i>
          {{$t('parallelProcess')}}
        </div>
      </div>
    </div>
    <div class="list-wrap" id="parent">
      <div class="list" v-for="(items,index) in currentGroup" :key="index">
        <div class="flow">
          <div class="name">{{$t('process')}}</div>
          <div class="flow-right">
            <i class="fa fa-trash icon-del" @click="deleteSubflow(index)"></i>
            <div class="add-icon" @click="selectApprovers(index)">
              <!-- @click="selectApprovers(item.isToPerson, item.id, item.submitTo, item.approverNumType, '', item.groupNum)" -->
              <img src="../assets/images/add.png" />
            </div>
          </div>
          
        </div>
        <div class="users" v-for="(item, i) in items.row" :key="i">
          <div class="user-left">
            <div class="photo">
              <img src="../assets/images/face.jpg">
            </div>
            <div class="user-name">
              {{item.name}}
            </div>
          </div>
          <div class="del-icon" @click="deleteUser(item.id, items, index)">
            <i class="fa fa-times-circle"></i>
          </div>
        </div>
      </div>
      <!-- this.$forceUpdate() //重新渲染数据 -->
      <div class="view-nodata" v-if="groupNumber==0">
        <div class="view-nodata-img">
          <i class="fa fa-inbox fa-5x"></i>
        </div>
        <div class="view-nodata-text">{{$t('notYetGrouped')}}</div>
      </div>
    </div>
    <div class="bottom-btns">
      <mt-button class="btn" type="primary" size="small" @click="onOk">{{$t('verify')}}</mt-button>
    </div>
  </div>
</template>

<script>
import { Toast } from 'mint-ui';
export default {
  props: [
    "approversObj",
    "flowId",
    "newSubflowData",
    "randomData",
    "subFlowToApprover"
  ],
  watch: {
    // newSubflowData: {
    //   handler() {
    //     for(let i=0; i<this.currentGroup.length; i++) {
    //       if(this.newSubflowData.index == i) {
    //         this.currentGroup[i] = this.newSubflowData
    //       }
    //     }
    //     this.currentGroup.splice(this.currentGroup.length, 1);
    //   },
    //   deep: true
    // },
    //newSubflowData只能监听第一次，所以先用下面的方法
    randomData() {
      for(let i=0; i<this.currentGroup.length; i++) {
        if(this.newSubflowData.index == i) {
          this.currentGroup[i] = this.newSubflowData
        }
      }
      this.currentGroup.splice(this.currentGroup.length, 1);
    },
  },
  data: function() {
    return {
      currentGroup:[],
      isShow:false,
      groupNumber:0,
    };
  },
 
  mounted() {
    this.listView();
  },
  methods: {
    showRemind() {
      this.isShow = !this.isShow;
    },
    //删除字流程
    deleteSubflow(index) {
      if(this.currentGroup.length < 2) {
        Toast({
          message: this.$t('atLeaseOneGroup'),
          position: 'center',
        }); 
      }else {
        this.currentGroup.splice(index, 1);
        this.$forceUpdate();
      }
    },
    //删除选中某个用户
    deleteUser(id, items, index) {
      items.row.forEach((item,index) => {
        if(id == item.id) {
          items.row.splice(index, 1);
        }
      });
      this.currentGroup[index].row = items.row;
      this.$forceUpdate() //重新渲染数据
    },
    onOk() {
      let groupLength = Object.assign({}, this.approversObj);
      if(this.currentGroup.length < groupLength.groupNum) {
        Toast({
          message: `分组不等于${groupLength.groupNum},请重新增删分组!`,
          position: 'center',
        });
      }else {
        let userid = [];
        let approverName = '';
        for(let i = 0; i < this.currentGroup.length; i++) {
          //this.currentGroup.position = i+1;
          let obj = {};
          obj.position = i+1;
          let arrId = [];
          let row = [];
          if(this.currentGroup[i].row && this.currentGroup[i].row.length >0 ) {
            let params = this.currentGroup[i].row;
            for(let j=0; j<params.length; j++) {
              arrId.push(params[j].id)
              approverName += params[j].name + ";";
              row.push(params[j]);
            }
            obj.userids = arrId;
            obj.rows = row;
            userid.push(obj);
          }else {
            Toast({
              message: `第${i+1}组用户不能为空`,
              position: 'center',
            });
            return false;
          }
        }
        let subObj = {
          approver:userid,
          nodeid:this.approversObj.nodeid,
        }
        let currentGroup = [...this.currentGroup];
        debugger
        this.$emit("event", approverName, subObj, currentGroup);  //调用form_normalform的subflowDataTopanel方法
      }
    },
    selectApprovers(i) {
      this.currentGroup[i].index = i
      this.currentGroup[i].position = i+1;
      this.$emit("action",this.currentGroup[i]);
    },
    addSubflow() {
      let obj = Object.assign({}, this.approversObj);
      if(obj.groupNum == -1) {
        obj.type = "subflow";
        this.currentGroup.push(obj);
        this.groupNumber++;
      }else {
        if(this.currentGroup.length < obj.groupNum) {
          obj.type = "subflow";
          this.currentGroup.push(obj);
          this.groupNumber++;
        }else {
          Toast({
            message: `分组不能大于${obj.groupNum}`,
            position: 'center',
          }); 
        }
      }
    },
    listView(){
      if(this.subFlowToApprover && this.subFlowToApprover.length>0) {
        this.currentGroup = JSON.parse(JSON.stringify(this.subFlowToApprover));
        this.groupNumber = this.currentGroup.length;
      }else {
        let parent = document.getElementById('parent');
        if(parent.children.length ==0){
          this.groupNumber = parent.children.length;
        }
      }
    }
  }
};
</script>
